/* #ident "@(#)tt.h - Header File for the Typing Tutor Package." */

/* #define PERFORMANCE */

#include <curses.h>
#include <malloc.h>

#define COPYRIGHT_LINE 7
#define ANNOUNCE_LEFT 4
#define INTER_NOTICE_SPACE 4
#define READ_TIME 4

#define TITLE_LINE 0
#define FILE_NAME_SIZE 128

#define TEXT_LEFT_SIDE 2
#define TEXT_TOP_LINE 1
#define WINDOW_SEPARATION 0

#define IN TRUE
#define OUT FALSE

#define SPACE ' '
#define VERTICAL '|'
#define HORIZONTAL '-'
#define UNDERLINE '_'
#define INSTRUCTION_FLAG ('^')
#define DATA_FLAG ('.')

#define TOP_WINDOW_HEIGHT 10
#define TOP_WINDOW_WIDTH COLS
#define TOP_WINDOW_ROW 1
#define TOP_WINDOW_COLUMN 0

#define MIDDLE_WINDOW_HEIGHT 6
#define MIDDLE_WINDOW_WIDTH TOP_WINDOW_WIDTH
#define MIDDLE_WINDOW_ROW \
	( TOP_WINDOW_ROW + TOP_WINDOW_HEIGHT + WINDOW_SEPARATION )
#define MIDDLE_WINDOW_COLUMN TOP_WINDOW_COLUMN

#define BOTTOM_WINDOW_HEIGHT MIDDLE_WINDOW_HEIGHT
#define BOTTOM_WINDOW_WIDTH TOP_WINDOW_WIDTH
#define BOTTOM_WINDOW_ROW \
	( MIDDLE_WINDOW_ROW + MIDDLE_WINDOW_HEIGHT + WINDOW_SEPARATION )
#define BOTTOM_WINDOW_COLUMN TOP_WINDOW_COLUMN

/*
 * Alternate Character set for the Qume qvt119 terminal.
 * Line drawing ACS names are of the form ACS_trbl, where t is the top, r
 * is the right, b is the bottom, and l is the left.  t, r, b, and l might
 * be B (blank), S (single), D (double), or T (thick).	The subset defined
 * here only uses B and S.
 */

#ifdef qvt119rv80

#undef ACS_BSSB
#undef ACS_SSBB
#undef ACS_BBSS
#undef ACS_SBBS
#undef ACS_SBSS
#undef ACS_SSSB
#undef ACS_SSBS
#undef ACS_BSSS
#undef ACS_BSBS
#undef ACS_SBSB
#undef ACS_SSSS

#define ACS_BSSB	(A_ALTCHARSET | 'f')
#define ACS_SSBB	(A_ALTCHARSET | 'e')
#define ACS_BBSS	(A_ALTCHARSET | 'g')
#define ACS_SBBS	(A_ALTCHARSET | 'h')
#define ACS_SBSS	(A_ALTCHARSET | 'l')
#define ACS_SSSB	(A_ALTCHARSET | 'm')
#define ACS_SSBS	(A_ALTCHARSET | 'o')
#define ACS_BSSS	(A_ALTCHARSET | 'n')
#define ACS_BSBS	(A_ALTCHARSET | 'k')
#define ACS_SBSB	(A_ALTCHARSET | 'j')
#define ACS_SSSS	(A_ALTCHARSET | 'i')
#endif

#undef border
#define border(win) wborder(win,\
ACS_VLINE, ACS_VLINE, ACS_HLINE, ACS_HLINE,\
ACS_ULCORNER, ACS_URCORNER, ACS_LLCORNER, ACS_LRCORNER ); wattrset(win, 0)

