/*  author: G. Matas                           (g.matas@ee.surrey.ac.uk)
*/
/* +-------------------------------------------------------------------+ */
/* | Copyright 1992, George Matas.                                     | */
/* |   Permission to use, copy, modify, and distribute this software   | */
/* |   and its documentation for any purpose and without fee is hereby | */
/* |   granted, provided that the above copyright notice appear in all | */
/* |   copies and that both that copyright notice and this permission  | */
/* |   notice appear in supporting documentation.  This software is    | */
/* |   provided "as is" without express or implied warranty.           | */
/* +-------------------------------------------------------------------+
*/
/*--------------------------------------------------------------------------*/
static char sccsid[]="@(#)93/06/30 g.matas@ee.surrey.ac.uk 5.1 PrintLL_ex.c";


#include "LL.h"


#include <stdio.h>                                   /* for printf, gets etc */
#include <string.h>                                        /* for strcmp etc */

/*------------------ LL library example ---------------------------------
    1.   Reads in a text file from the stdio  ( sort_ex  <file)
    2.   Sorts line in alphabetical order
    3.   Prints out line number + line using PrintLL

  DEMONSTRATES:
     how to use PrintLL;

-----------------------------------------------------------------------*/
/* declarations missing in our standard headers ...  */
int strcasecmp(char *, char *);


typedef struct { 
           int         line_no;
           char        text[300];
	   } elem ;

elem elm;
t_LL list;



static int AlfComp(const void  * el1, const void  * el2)
{                   /* for SortLL, case sensitive  */
  return strcmp(((elem   const *)el1)->text, ((elem  const *)el2)->text);
}

#ifdef CASE_SENS
static int AlfCompC(const void  * el1, const void  * el2)
{                   /* for SortLL, case sensitive  */
  return strcasecmp(((elem const  *)el1)->text, ((elem const *)el2)->text);
}
#endif


int  main(int argc, char ** argv)
{
  int line_num=0;
  elem  buffer;
  char * control;

  list = ConsLL();

  if (argc > 1) 
    control = argv[1];
  else 
    control = "\nLine: %3d Text: %S--|";

  while(-1!=scanf("\n%[^\n]",&buffer.text)){
    buffer.line_no= ++line_num;
    InsLastLLf(list,sizeof(int)+strlen(buffer.text)+1,&buffer);  
  }

  SortLL(list, AlfComp);

  printf("Sorted list:\n");
  FprintLL(list,stdout,"",control,"");
  printf("\n\n");

  return 0;
}

