/*  author: G. Matas                           (g.matas@ee.surrey.ac.uk)
*/
/* +-------------------------------------------------------------------+ */
/* | Copyright 1992, George Matas.                                     | */
/* |   Permission to use, copy, modify, and distribute this software   | */
/* |   and its documentation for any purpose and without fee is hereby | */
/* |   granted, provided that the above copyright notice appear in all | */
/* |   copies and that both that copyright notice and this permission  | */
/* |   notice appear in supporting documentation.  This software is    | */
/* |   provided "as is" without express or implied warranty.           | */
/* +-------------------------------------------------------------------+
*/
/*-----------------------------------------------------------------------*/
static char sccsid[]="@(#)93/06/30 g.matas@ee.surrey.ac.uk 5.1 man_ex1.c";



#include "LL.h"
#include <stdio.h>
#include <stdlib.h>

static int cmp(const void *n1,const void *n2)        /* comparison function for SortLL */
{
   if     ( *(const int*)n1 > *(const int*)n2) return  1;
   if     ( *(const int*)n1 < *(const int*)n2) return -1;
                                   return  0; 
} 

static void *negate(void *n)      /* function called by ApplyLL */
{
  *(int*)n=-*(int*)n;
  return NULL;                    /* do it for all elements */
}

int main(int argc, char ** argv)
{
  t_LL num = ConsLL();
  int **look_tab1, **look_tab_s, **look_tab_n;
  
  int some_num [] = { 7, 3 , 8, 1, 19};

  {                      /* insert all numbers in some_num  into the list  */
    int i;
    printf("list: ");
    for (i=0; i < sizeof(some_num)/sizeof(int); i++){
      InsLastLL(num,some_num[i]);
      printf("%d ",some_num[i]);
    }
    printf("\n\n");
  }

  look_tab1 = LookInLL(num);              /* accessing some random elements  */
  printf("start:    3rd and 4th : %d %d\n\n", *look_tab1[3],*look_tab1[4]);
  
  SortLL(num,cmp);
  look_tab_s = LookInLL(num);
  printf("original: 3rd and 4th : %d %d\n", *look_tab1[3],*look_tab1[4]);
  printf("sorted:   3rd and 4th : %d %d\n\n", *look_tab_s[3],*look_tab_s[4]);
  
  ApplyLL(num,negate);
  SortLL(num,cmp);
  look_tab_n = LookInLL(num);
  printf("original: 3rd and 4th : %d %d\n", *look_tab1[3], *look_tab1[4]);
  printf("sorted:   3rd and 4th : %d %d\n", *look_tab_s[3],*look_tab_s[4]);
  printf("neg-sort: 3rd and 4th : %d %d\n\n", *look_tab_n[3],*look_tab_n[4]);

  DestLL(num);                      /* clean up, destroy list */ 
  free(look_tab1);
  free(look_tab_s);
  free(look_tab_n);
  return 0;
}
