/*  author: G. Matas                           (g.matas@ee.surrey.ac.uk)
*/
/* +-------------------------------------------------------------------+ */
/* | Copyright 1992, George Matas.                                     | */
/* |   Permission to use, copy, modify, and distribute this software   | */
/* |   and its documentation for any purpose and without fee is hereby | */
/* |   granted, provided that the above copyright notice appear in all | */
/* |   copies and that both that copyright notice and this permission  | */
/* |   notice appear in supporting documentation.  This software is    | */
/* |   provided "as is" without express or implied warranty.           | */
/* +-------------------------------------------------------------------+
*/
/*-----------------------------------------------------------------------*/
static char sccsid[]="@(#)93/06/30 g.matas@ee.surrey.ac.uk 5.1 membrane.c";



#include "LL.h"

#include <stdio.h>                                   /* for printf, gets etc */
#include <string.h>                                        /* for strcmp etc */
#include <time.h>                         /* time used for random num. inic. */
#include <stdlib.h>          /* for random number generator (pre-ANSI)       */
#include <math.h>            /* for random number generator (ANSI header)    */


/*------------------ LL library example ---------------------------------
   1. Generate a list containig one random number (range 0-99)
   2. Iteratively:
	a/  replace all numbers under EXP_THRESH (def. 30) by EXP_NUMBER
	    (def. 3) succesors
   3. Terminte when no replacement took place

-----------------------------------------------------------------------*/

#define EXP_THRESH 45   /* keep EXP_THRESH * EXP_NUMBER <100 for convergence */
#define EXP_NUMBER 2


/* generate random number in <0,100) */
static void InitRand0_100 (void)   { srand((unsigned int) time(NULL));}
static int  Rand0_100 (void)       { return rand()%100; }
 

int main(void)
{
  int one_expanded,i;
  int *el, * next;
  int ran;
  t_LL membrane     = ConsLL();
  t_LL new_string   = ConsLL();
  
  InitRand0_100();                      /* initialize the random generator */
  ran = Rand0_100();
  InsFirstLL(membrane,ran);             /* insert something in the list    */

			     
  do {
	    /* go through the list and expand elements < expand. threshold */
    printf("List:  ");
    FprintLL(membrane,stdout,"","%3d","");
    printf("\n");
			 /*  print out the current contents */
    one_expanded = 0;
    SafeForeachLL_M(membrane,el,next){
      next = NextElmLL(el);
      if (*el < EXP_THRESH) {
	   one_expanded = 1;  
	   for (i=0; i<EXP_NUMBER; i++){
	      ran = Rand0_100();
	      InsLastLL(new_string,ran);
	   }
           MoveListBefLL(el,new_string);
           DelElmLL(el);
	 }
    }
  }while (one_expanded);
  
  DestLL(membrane);                              /* clean up */

  return 0;
}
