/*  author: G. Matas                           (g.matas@ee.surrey.ac.uk)
*/
/* +-------------------------------------------------------------------+ */
/* | Copyright 1992, George Matas.                                     | */
/* |   Permission to use, copy, modify, and distribute this software   | */
/* |   and its documentation for any purpose and without fee is hereby | */
/* |   granted, provided that the above copyright notice appear in all | */
/* |   copies and that both that copyright notice and this permission  | */
/* |   notice appear in supporting documentation.  This software is    | */
/* |   provided "as is" without express or implied warranty.           | */
/* +-------------------------------------------------------------------+
*/
/*-----------------------------------------------------------------------*/
static char sccsid[]="@(#)93/06/30 g.matas@ee.surrey.ac.uk 5.1 sort_simple.c";



#include "LL.h"

#include <stdio.h>                                   /* for printf, gets etc */
#include <string.h>                                        /* for strcmp etc */


/*------------------ LL library example ---------------------------------
    1.   Reads in a text file from the stdio  ( sort_ex  <file)
    2.   Sorts line in alphabetical order
    3.   prints out lines 

  DEMONSTRATES:
    b/  how simple it is to sort a file using the library
    c/  how to store a string (not a pointer to it) in a list
-----------------------------------------------------------------------*/
static void *  printelm(void * elm)  { printf("%s\n",(char*)elm); return NULL; }
static int sCmp(const void * s1, const void * s2) { return strcmp(s1,s2);}

int main(void)
{
  char  buffer[200];
  t_LL list = ConsLL();

  while(-1!=scanf("\n%[^\n]",buffer)){
    InsLastLLf(list,strlen(buffer)+1,buffer);  
  }

  fprintf(stderr,"SortLL start -- ");
  SortLL(list, sCmp);
  fprintf(stderr,"end\n");

  ApplyLL(list,printelm);

  return 0;
}


